#
# Makefile Template for Tessy
#
# Compiler   : Keil XC166 (Keil Software Inc.)
# Environment: Keil Vision3 (Keil Software Inc.)
# Template Version : 1
#

# Defines to be generated by Tessy:
#
# TESSY_SYS					:=
# MODULE_PATH				:=
# TESTOBJECT				:=
# USER_LINK_OPTIONS		:=
# COMPILER_INSTALL_PATH	:=
# TARGET_INSTALL_PATH	:=

#####################################################################
#BEGIN_DEFINES
#####################################################################

TESSY_SYS_DOS   := $(shell ts_pathname -s $(TESSY_SYS))
MODULE_PATH_DOS := $(shell ts_pathname -s $(MODULE_PATH))
KEIL_HOME       := $(shell ts_pathname -rs '$(COMPILER_INSTALL_PATH)')
LINK_FILE_SHORT := $(shell ts_pathname -s '$(LINKER_FILE)')
UVSC_HOME       := $(shell ts_pathname -s '$(TARGET_INSTALL_PATH)')


TS_NAME         := TS_UVISION
IDE_NAME        := uvision_uvsc
COMPANY_NAME    := keil
PROCESSOR_NAME  := c166

all	   : master slave
master : $(MODULE_PATH)/ts_$(TESTOBJECT)_m.exe
slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(BINARY_POSTFIX)


#

#
# MASTER & COMM Makefiles
# (you should not need to modify these settings)
#
M_COMM_MAKE     := $(TESSY_SYS)/make/master_$(IDE_NAME)_gnu_i386.mk
S_COMM_MAKE     := $(TESSY_SYS)/src/comm/comm_$(IDE_NAME)_$(COMPANY_NAME)_$(PROCESSOR_NAME).mk


#
# SLAVE
#
S_INCLUDES		:= $(TESSY_SYS_DOS)\include\tessy\comm
S_ASM_INCLUDES	:=	$(KEIL_HOME)\ASM
S_COMP_OPTIONS := SMALL DEBUG OT "(0)" MODV2 BROWSE NOFIXDPP WARNINGLEVEL "(0)" INCDIR "($(S_INCLUDES))" DEFINE "(TESSY,TS_SLAVE,TS_UVISION,TS_C166)" NOPR
S_LINK_OPTIONS	:=

S_CC				:=	$(KEIL_HOME)/BIN/C166.EXE
S_ASM				:=	$(KEIL_HOME)/BIN/A166.EXE
S_LINK			:=	$(KEIL_HOME)/BIN/L166.EXE
S_OBJECTS  		:= $(MODULE_PATH_DOS)\tslows_uvision$(OBJECT_POSTFIX) \
             		$(MODULE_PATH_DOS)\tstcomm$(OBJECT_POSTFIX) \
             		$(MODULE_PATH_DOS)\tscoml$(OBJECT_POSTFIX) \
             		$(MODULE_PATH_DOS)\ts_timer_c166$(OBJECT_POSTFIX)
S_STUB_OBJECT  := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs$(OBJECT_POSTFIX)
S_UC_OBJECT    := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr$(OBJECT_POSTFIX)

CLASS_RANGE		:= CLASSES (ICODE (0x0-0x7FFF), NCODE (0x10000-0x1FFFF), \
FCONST (0x0-0x7FFF, 0x10000-0x1FFFFF), HCONST (0x0-0x7FFF, 0x10000-0x1FFFFF), \
XCONST (0x0-0x7FFF, 0x10000-0x1FFFFF), NCONST (0x4000-0x7FFF), \
NDATA (0x400000-0x403FFF), NDATA0 (0x400000-0x403FFF), \
SDATA (0xC000-0xCFFF, 0xF600-0xFDFF), SDATA0 (0xC000-0xCFFF, 0xF600-0xFDFF), \
IDATA (0xF600-0xFDFF), IDATA0 (0xF600-0xFDFF), \
FDATA (0x400000-0x47FFFF), FDATA0 (0x400000-0x47FFFF), \
HDATA (0x400000-0x47FFFF), HDATA0 (0x400000-0x47FFFF), \
XDATA (0x400000-0x47FFFF), XDATA0 (0x400000-0x47FFFF)) \
 CINITTAB (0x10000-0x1FFFFF)

LOFLAGS			:= $(CLASS_RANGE) DISABLEWARNING (20)


COMMA				:=	,
S_OBJECT_LIST	:=	$(foreach file,$(S_OBJECTS),$(addsuffix $(COMMA),$(file)))



#####################################################################
#END_DEFINES
#####################################################################

# Targets to be defined by Tessy
#
# for each source
#
# S_SRC_OBJECTS      := $(MODULE_PATH)/ts_src01.o ... ts_srcnn.o
# USER_COMP_OPTIONS* :=
#
# $(MODULE_PATH)/ts_src*.o : $(MODULE_PATH)/ts_src*.c
#     $(S_CC) $< $(S_COMP_OPTIONS) $(USER_COMP_OPTIONS*) OBJECT "($@)"

#####################################################################
#BEGIN_TARGETS
#####################################################################

S_SRC_LIST	:= $(foreach file,$(S_SRC_OBJECTS),$(addsuffix $(COMMA),$(file)))

#
# COPY USERCODE / STUBS / DRIVER
#
$(MODULE_PATH_DOS)\ts_t_usr.c : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.c
	@ts_cp $< $@

$(MODULE_PATH_DOS)\ts_t_stubs.c : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.c
	@ts_cp $< $@

$(MODULE_PATH_DOS)\ts_t_s.c : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.c
	@ts_cp $< $@


#
# COMPILE USERCODE / STUBS
#
$(S_UC_OBJECT) : $(MODULE_PATH_DOS)\ts_t_usr.c
	$(S_CC) $< $(S_COMP_OPTIONS) OBJECT "($@)"

$(S_STUB_OBJECT) : $(MODULE_PATH_DOS)\ts_t_stubs.c
	$(S_CC) $< $(S_COMP_OPTIONS) OBJECT "($@)"

#
# COMPILE/LINK MASTER
#
include $(M_COMM_MAKE)


#
# COMPILE SLAVE COMMUNICATION MODULES
#
include $(S_COMM_MAKE)


#
# COMPILE/LINK SLAVE
#
$(MODULE_PATH_DOS)\ts_start$(OBJECT_POSTFIX)	:	$(KEIL_HOME)\Lib\start_v2.a66
	$(S_ASM) $< MODV2 SEGMENTED SET (SMALL) DEBUG EP ID "($(S_ASM_INCLUDES))" OBJECT "($@)"

$(MODULE_PATH_DOS)\ts_t_s$(OBJECT_POSTFIX) : $(MODULE_PATH_DOS)\ts_t_s.c
	@echo *
	@echo ***** Copying Header Files *****
	@ts_cp $(TESSY_SYS_DOS)\include\tessy\comm\tsteval.h $(MODULE_PATH_DOS)
	@ts_cp $(TESSY_SYS_DOS)\include\tessy\comm\tstcomm_base.h $(MODULE_PATH_DOS)
	@ts_cp $(TESSY_SYS_DOS)\include\tessy\comm\tessy_types.h $(MODULE_PATH_DOS)
	@echo ***** Compiling Slave *****
	$(S_CC) $< $(S_COMP_OPTIONS) OBJECT "($@)"

$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(BINARY_POSTFIX) : $(MODULE_PATH_DOS)\ts_t_s$(OBJECT_POSTFIX) \
																			$(S_SRC_OBJECTS) \
																			$(S_UC_OBJECT) \
																			$(S_STUB_OBJECT) \
																			$(MODULE_PATH_DOS)\ts_start$(OBJECT_POSTFIX) \
																			$(S_OBJECTS)

	@echo *
	@echo ***** Linking Slave *****
	@echo $(MODULE_PATH_DOS)\ts_t_s$(OBJECT_POSTFIX), > $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@sh -c 'for f in $(S_OBJECTS); do echo "$$f," >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin; done'
	@sh -c 'for f in $(S_SRC_OBJECTS); do echo "$$f," >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin; done'
	@echo $(S_UC_OBJECT), >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@sh -c 'for f in $(USER_LINK_OPTIONS); do echo "$$f," >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin; done'
	@echo $(S_STUB_OBJECT), >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@echo $(MODULE_PATH_DOS)\ts_start$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@echo TO $@ >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@echo $(LOFLAGS) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin

	$(S_LINK) "@$(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin"


#####################################################################
#END_TARGETS
#####################################################################
